<?php
/**
 * If adding meta keywords or description to a page, and the values are empty, then populate them with default meta details from config file
 *
 * Add default meta keyword and description to a page
 *
 * LICENSE: Some license information
 *
 * @copyright		2012 Richard Parnaby-King
 * @since			File available 0.0.1
 */

class RPK_View_Helper_HeadMeta extends Zend_View_Helper_HeadMeta
{

  /**
   * If value name = keywords or description, check if content is null. If it is, then populate with default
   * meta details.
   *
   * @param  string $value
   * @return void
   * @throws Zend_View_Exception
   */
  public function set($value)
  {
    if ($value->type == 'name' AND ($value->content == null OR strlen($value->content) === 0) AND ($value->name == 'keywords' OR $value->name == 'description'))
    {
	  $config = Zend_Controller_Front::getInstance()->getParam('bootstrap')->getOptions();
      switch ($value->name)
      {
        case 'keywords':
          $setting = $config['default']['meta']['keywords'];
          break;
        case 'description':
          $setting = $config['default']['meta']['description'];
          break;
      }
      if ($setting)
      {
        $value->content = $setting;
      }
    }

    if (!$this->_isValid($value))
    {
      $e = new Zend_View_Exception('Invalid value passed to append; please use appendMeta()');
      $e->setView($this->view);
      throw $e;
    }

    return $this->getContainer()->append($value);
  }